# -*- coding: utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
import os.path, sys

class convertorPlugin:
	def __init__( self, iface ):
		self.iface = iface
		try:
			self.QgisVersion = unicode( QGis.QGIS_VERSION_INT )
		except:
			self.QgisVersion = unicode( QGis.qgisVersion )[ 0 ]
		
		# static messages
		self.wrongVersion = QCoreApplication.translate( "Convertor", "Quantum GIS version detected: " +
		str( self.QgisVersion ) + "\n" + "Convertor plugin requires version at least 1.0.0!\n" +
		"Plugin not loaded." )
	
	def initGui( self ):
		# check Qgis version
		if int( self.QgisVersion ) < 1:
			QMessageBox.warning( self.iface.mainWindow(), "Convertor", self.wrongVersion )
			return None
		
		# create plugin menu
		self.convert = QAction( QCoreApplication.translate( "CovertorMenu", "Convertor" ), self.iface.mainWindow() )
		self.iface.addPluginToMenu( "Convertor", self.convert )
		
		QObject.connect( self.convert, SIGNAL( "triggered()" ), self.doConvert )
	
	def unload( self ):
		self.iface.removePluginMenu( "Convertor", self.convert )
	
	def doConvert( self ):
		# Return QgsVectorLayer from a layer name ( as string )
		layermap = QgsMapLayerRegistry.instance().mapLayers()
		for name, layer in layermap.iteritems():
			if layer.type() == QgsMapLayer.VectorLayer and layer.name() == u'source':
				if layer.isValid():
					vlayerA = layer
				else:
					vlayerA = None
		
		layermap = QgsMapLayerRegistry.instance().mapLayers()
		for name, layer in layermap.iteritems():
			if layer.type() == QgsMapLayer.VectorLayer and layer.name() == u'cities':
				if layer.isValid():
					vlayerB = layer
				else:
					vlayerB = None
		
		vproviderA = vlayerA.dataProvider()
		allAttrsA = vproviderA.attributeIndexes()
		vproviderA.select( allAttrsA )
		fieldsA = vproviderA.fields()
		
		vproviderB = vlayerB.dataProvider()
		#allAttrsB = vproviderB.attributeIndexes()
		#vproviderB.select( allAttrsB )
		#fieldsB = vproviderB.fields()
		
		#outFeat = QgsFeature()
		inFeat = QgsFeature()
		Geom = QgsGeometry()
		lstFeatures = []
		
		#QMessageBox.warning( self.iface.mainWindow(), "DEBUG", str( len( lstFeatures ) ) )
		vproviderA.rewind()
		while vproviderA.nextFeature( inFeat ):
			atMapA = inFeat.attributeMap()
			Geom = QgsGeometry( inFeat.geometry() ) 
			outFeat = QgsFeature()
			outFeat.setGeometry( Geom )
			#QMessageBox.warning( self.iface.mainWindow(), "DEBUG", atMapA[4].toString() )
			#outFeat.addAttribute(1, QVariant(atMapA[0].toString().trimmed()))
			#outFeat.addAttribute(2, QVariant(atMapA[1].toString().trimmed()))
			#outFeat.addAttribute(3, QVariant(atMapA[2].toString().trimmed()))
			#outFeat.addAttribute(4, QVariant(atMapA[3].toString().trimmed()))
			#outFeat.addAttribute(5, QVariant(atMapA[4].toString().trimmed()))
			#outFeat.addAttribute(6, QVariant(atMapA[5].toString().trimmed()))
			#outFeat.addAttribute(7, QVariant(atMapA[6].toString().trimmed()))
			#outFeat.addAttribute(8, QVariant(atMapA[8].toString().trimmed()))
			lstFeatures.append( outFeat )
		
		QMessageBox.warning( self.iface.mainWindow(), "DEBUG", 'Converting completed!' )
		#QMessageBox.warning( self.iface.mainWindow(), "DEBUG", str( len( lstFeatures ) ) )
		vproviderB.addFeatures( lstFeatures )
		#self.iface.mapCanvas.refresh()
	
